<html>
<head>
<title>OGRE: OgreMaterialScriptCompiler.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_2ff5b5fbc695dec6c750a718c789bf4d.html">Attic</a></div>
<h1>Attic/OgreMaterialScriptCompiler.h</h1><a href="Attic_2OgreMaterialScriptCompiler_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __MaterialScriptScompiler_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __MaterialScriptScompiler_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreCompiler2Pass_8h.html">OgreCompiler2Pass.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreTextureUnitState_8h.html">OgreTextureUnitState.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreMaterial_8h.html">OgreMaterial.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>"</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include "<a class="code" href="OgreStringVector_8h.html">OgreStringVector.h</a>"</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html">00041</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1MaterialScriptCompiler.html">MaterialScriptCompiler</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Compiler2Pass.html" title="Compiler2Pass is a generic 2 pass compiler/assembler.">Compiler2Pass</a>
<a name="l00042"></a>00042     {
<a name="l00043"></a>00043 
<a name="l00044"></a>00044     <span class="keyword">public</span>:
<a name="l00045"></a>00045         <a class="code" href="classOgre_1_1MaterialScriptCompiler.html">MaterialScriptCompiler</a>(<span class="keywordtype">void</span>);
<a name="l00046"></a>00046         ~<a class="code" href="classOgre_1_1MaterialScriptCompiler.html">MaterialScriptCompiler</a>(<span class="keywordtype">void</span>);
<a name="l00047"></a>00047 
<a name="l00050"></a>00050         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getClientBNFGrammer(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00051"></a>00051 
<a name="l00054"></a>00054         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getClientGrammerName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00055"></a>00055 
<a name="l00066"></a>00066         <span class="keywordtype">void</span> parseScript(<a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">DataStreamPtr</a>&amp; stream, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; groupName, <span class="keyword">const</span> <span class="keywordtype">bool</span> allowOverride = <span class="keyword">false</span>);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <span class="keyword">protected</span>:
<a name="l00069"></a>00069         <span class="comment">// Token ID enumeration</span>
<a name="l00070"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138">00070</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138">TokenID</a> {
<a name="l00071"></a>00071             <span class="comment">// Terminal Tokens section</span>
<a name="l00072"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138964ef2ae001b91e63626d2609302a23d">00072</a>             ID_UNKOWN = 0,
<a name="l00073"></a>00073             <span class="comment">// GPU Program</span>
<a name="l00074"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c51383611840aa23953b94b4548818fad5a4d">00074</a>             ID_VERTEX_PROGRAM, ID_FRAGMENT_PROGRAM,
<a name="l00075"></a>00075 
<a name="l00076"></a>00076             <span class="comment">// material</span>
<a name="l00077"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138d0c9645baf2f233936331d6669aa517c">00077</a>             ID_CLONE,
<a name="l00078"></a>00078 
<a name="l00079"></a>00079             <span class="comment">// technique</span>
<a name="l00080"></a>00080 
<a name="l00081"></a>00081             <span class="comment">// pass</span>
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c51386dd1ec46f3f9043c1bd5caea4903afdc">00083</a>             ID_VERTEXCOLOUR,
<a name="l00084"></a>00084             <span class="comment">// scene blend</span>
<a name="l00085"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c51389659b1627accd8906dcfed39b1a522fd">00085</a>             ID_COLOUR_BLEND, ID_DEST_COLOUR,
<a name="l00086"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c51386c00db2bb40137f00d48800878374e21">00086</a>             ID_SRC_COLOUR, ID_ONE_MINUS_DEST_COLOUR, ID_ONE_MINUS_SRC_COLOUR,
<a name="l00087"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138093052d34effcb32098e032def89b33c">00087</a>             ID_DEST_ALPHA, ID_SRC_ALPHA, ID_ONE_MINUS_DEST_ALPHA, ID_ONE_MINUS_SRC_ALPHA,
<a name="l00088"></a>00088             <span class="comment">// Depth</span>
<a name="l00089"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138496aff7f6877b113a85bfe2e4a704702">00089</a>             ID_ALWAYS_FAIL, ID_ALWAYS_PASS,
<a name="l00090"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c513899ac0ba88540b059bd7e900ac73a9749">00090</a>             ID_LESS_EQUAL, ID_LESS, ID_EQUAL, ID_NOT_EQUAL, ID_GREATER_EQUAL, ID_GREATER,
<a name="l00091"></a>00091             <span class="comment">// culling</span>
<a name="l00092"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138deb0a5f011681cdaf5c58aaf28f212d2">00092</a>             ID_CLOCKWISE, ID_ANTICLOCKWISE,
<a name="l00093"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138c5ecd1c5f7b5a9331e1885ab0237e24e">00093</a>             ID_CULL_BACK, ID_CULL_FRONT,
<a name="l00094"></a>00094             <span class="comment">// shading</span>
<a name="l00095"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138bf1db6b8799de5e7da4db32e1acc1890">00095</a>             ID_FLAT, ID_GOURAUD, ID_PHONG,
<a name="l00096"></a>00096             <span class="comment">// polygon mode</span>
<a name="l00097"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138bcd494070a0ebd710e976153b5560916">00097</a>             ID_SOLID, ID_WIREFRAME, ID_POINTS,
<a name="l00098"></a>00098             <span class="comment">// fog overide</span>
<a name="l00099"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138b014accb34d2f7ea65c3e9f0ae7f7571">00099</a>             ID_EXP, ID_EXP2,
<a name="l00100"></a>00100             <span class="comment">// iteration</span>
<a name="l00101"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c51389242337f8e2f6c28a5ca1f9c762499c6">00101</a>             ID_ONCE, ID_ONCE_PER_LIGHT, ID_PER_LIGHT, ID_PER_N_LIGHTS, ID_DIRECTIONAL, ID_SPOT,
<a name="l00102"></a>00102 
<a name="l00103"></a>00103             <span class="comment">// texture unit state</span>
<a name="l00104"></a>00104             <span class="comment">// texture</span>
<a name="l00105"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c51389d3e93056dfa431b2c733faaff907126">00105</a>             ID_1D, ID_2D, ID_3D, ID_CUBIC, ID_UNLIMITED, ID_ALPHA,
<a name="l00106"></a>00106             <span class="comment">// cubic texture</span>
<a name="l00107"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138b5aafa4a704e1aaa76db4aca5cb5dab3">00107</a>             ID_SEPARATE_UV, ID_COMBINED_UVW,
<a name="l00108"></a>00108             <span class="comment">// address mode</span>
<a name="l00109"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c51381f19a54ccfff94475e441fc2bed50d9c">00109</a>             ID_WRAP, ID_CLAMP, ID_MIRROR, ID_BORDER,
<a name="l00110"></a>00110             <span class="comment">// filtering</span>
<a name="l00111"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138b6a7d648b18b292986e2d6fcedb7225b">00111</a>             ID_BILINEAR, ID_TRILINEAR, ID_ANISOTROPIC,
<a name="l00112"></a>00112             <span class="comment">// color op</span>
<a name="l00113"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c513835d664a4bc78bacfbaef257cdc9fc90d">00113</a>             ID_REPLACE,
<a name="l00114"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138e6530647db3db1c2887fa1e0535c18b7">00114</a>             ID_SOURCE1, ID_SOURCE2, ID_MODULATE_X2, ID_MODULATE_X4, ID_ADD_SIGNED,
<a name="l00115"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c51387821ce1ddfe389dc1d4a47cfb4a1a27b">00115</a>             ID_ADD_SMOOTH, ID_SUBTRACT, ID_BLEND_DIFFUSE_COLOUR, ID_BLEND_DIFFUSE_ALPHA,
<a name="l00116"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138589ad98d9e116afebb45eca6c61882bc">00116</a>             ID_BLEND_TEXTURE_ALPHA, ID_BLEND_CURRENT_ALPHA, ID_BLEND_MANUAL, ID_DOTPRODUCT,
<a name="l00117"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138ad2cb85a9458bfc18c48353a1f9b0021">00117</a>             ID_SRC_CURRENT, ID_SRC_TEXTURE, ID_SRC_DIFFUSE, ID_SRC_SPECULAR, ID_SRC_MANUAL,
<a name="l00118"></a>00118 
<a name="l00119"></a>00119             <span class="comment">// env map</span>
<a name="l00120"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138de4ac10464e294a058a0ebaf8a817035">00120</a>             ID_SPHERICAL, ID_PLANAR, ID_CUBIC_REFLECTION, ID_CUBIC_NORMAL,
<a name="l00121"></a>00121             <span class="comment">// wave transform</span>
<a name="l00122"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c51385a0ce6b21de44b5f91a547ce053bee73">00122</a>             ID_SCROLL_X, ID_SCROLL_Y, ID_SCALE_X, ID_SCALE_Y, ID_SINE, ID_TRIANGLE,
<a name="l00123"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138de1792b1f924456bc1daf303e20156e3">00123</a>             ID_SQUARE, ID_SAWTOOTH, ID_INVERSE_SAWTOOTH, ID_ROTATE,
<a name="l00124"></a>00124             <span class="comment">// content type</span>
<a name="l00125"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c51380ba6fb2faae715733cca81f30441c1bf">00125</a>             ID_NAMED, ID_SHADOW,
<a name="l00126"></a>00126 
<a name="l00127"></a>00127             <span class="comment">// GPU program references</span>
<a name="l00128"></a>00128             <span class="comment">// GPU Parameters</span>
<a name="l00129"></a>00129 
<a name="l00130"></a>00130             <span class="comment">// general</span>
<a name="l00131"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138d69c3f5f0532785fa03c3662f39d8a69">00131</a>             ID_ON, ID_OFF, ID_TRUE, ID_FALSE, ID_NONE, ID_POINT, ID_LINEAR, ID_ADD, ID_MODULATE, ID_ALPHA_BLEND,
<a name="l00132"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138fec70f0669e2183a6e5f6eae01d398ee">00132</a>             ID_ONE, ID_ZERO, ID_VERTEX, ID_FRAGMENT,
<a name="l00133"></a>00133 
<a name="l00134"></a>00134             <span class="comment">// where auto generated tokens start so donot remove</span>
<a name="l00135"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#be20f82a34fc07a018c334c1de2c5138ca1161a45ee333e879047dbcd5df2f45">00135</a>             ID_AUTOTOKENSTART
<a name="l00136"></a>00136         };
<a name="l00137"></a>00137 
<a name="l00139"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#c87b6d292401a48e50ceca7c3bb147dc">00139</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1MaterialScriptCompiler.html#c87b6d292401a48e50ceca7c3bb147dc" title="Enum to identify material sections.">MaterialScriptSection</a>
<a name="l00140"></a>00140         {
<a name="l00141"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#c87b6d292401a48e50ceca7c3bb147dc32e9323fa6e27330af0341d1e676ffff">00141</a>             <a class="code" href="namespaceOgre.html#83c5c9e6cd44a657c97dd7494800676ca8ecf2298f0401fa132fbe09d7306e22">MSS_NONE</a>,
<a name="l00142"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#c87b6d292401a48e50ceca7c3bb147dc0468e6263e06ab0fca238dee783e57ec">00142</a>             <a class="code" href="namespaceOgre.html#83c5c9e6cd44a657c97dd7494800676c03535ff3b3deaf08ce6e4cf28f247396">MSS_MATERIAL</a>,
<a name="l00143"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#c87b6d292401a48e50ceca7c3bb147dc8fa0c8d933f1948ffd66c2536181334c">00143</a>             <a class="code" href="namespaceOgre.html#83c5c9e6cd44a657c97dd7494800676c75dcdf27cd2c26a79997de2e6670f4a1">MSS_TECHNIQUE</a>,
<a name="l00144"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#c87b6d292401a48e50ceca7c3bb147dcdab60fba662cee432137f76affb4f7eb">00144</a>             <a class="code" href="namespaceOgre.html#83c5c9e6cd44a657c97dd7494800676c4dbef3e527e942ad0fdf8790ff79ca91">MSS_PASS</a>,
<a name="l00145"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#c87b6d292401a48e50ceca7c3bb147dc00a2fafcae803537dea3122515daeb5b">00145</a>             <a class="code" href="namespaceOgre.html#83c5c9e6cd44a657c97dd7494800676cf7bf31ae13f2c3b042d78aa28626b1e5">MSS_TEXTUREUNIT</a>,
<a name="l00146"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#c87b6d292401a48e50ceca7c3bb147dc3823b169cb3d99a42785bc8a344d1947">00146</a>             <a class="code" href="namespaceOgre.html#83c5c9e6cd44a657c97dd7494800676cc22fc0112f378c4652e0335c5369a501">MSS_PROGRAM_REF</a>,
<a name="l00147"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#c87b6d292401a48e50ceca7c3bb147dcea120197654bb29b77a6ddb75c3d43cd">00147</a>             <a class="code" href="namespaceOgre.html#83c5c9e6cd44a657c97dd7494800676c1482036b89dfe855d5722f4280bb9136">MSS_PROGRAM</a>,
<a name="l00148"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#c87b6d292401a48e50ceca7c3bb147dcd3f88b2fdb824dce98bf598e3af1eb2b">00148</a>             <a class="code" href="namespaceOgre.html#83c5c9e6cd44a657c97dd7494800676c485e4dd851bfd5d5db3ca78b4a031d44">MSS_DEFAULT_PARAMETERS</a>,
<a name="l00149"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#c87b6d292401a48e50ceca7c3bb147dcd19d99222f1c01b5bd69812961fb7bd5">00149</a>             <a class="code" href="namespaceOgre.html#83c5c9e6cd44a657c97dd7494800676cdd3efa1f0af549e1fbe112beb544bf69">MSS_TEXTURESOURCE</a>
<a name="l00150"></a>00150         };
<a name="l00152"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html">00152</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html" title="Struct for holding a program definition which is in progress.">MaterialScriptProgramDefinition</a>
<a name="l00153"></a>00153         {
<a name="l00154"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html#953f92f5c618abd6d6db5c0055254225">00154</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> name;
<a name="l00155"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html#6fd897faa862fcc97511ebfc30afb1b0">00155</a>             <a class="code" href="namespaceOgre.html#d08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> progType;
<a name="l00156"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html#d032b0b3e92422841c6e37e2f78014b7">00156</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> language;
<a name="l00157"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html#272a7940595ca0d7829769f9a9d41a82">00157</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> source;
<a name="l00158"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html#4e60a2d5238aa8120d4718f0e8d87c72">00158</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> syntax;
<a name="l00159"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html#389c1dee2f778d03a5db397749515d29">00159</a>             <span class="keywordtype">bool</span> supportsSkeletalAnimation;
<a name="l00160"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html#1cfa6ed9daaef6772840cbfccf920c19">00160</a>             <span class="keywordtype">bool</span> supportsMorphAnimation;
<a name="l00161"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html#07ef4cd51676e5db28c810e57100e7e7">00161</a>             <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> supportsPoseAnimation; <span class="comment">// number of simultaneous poses supported</span>
<a name="l00162"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html#b85633173348ff64a2e588efff55bf96">00162</a>             <span class="keywordtype">bool</span> usesVertexTextureFetch;
<a name="l00163"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html#f608d1961f09c4944534b7fef449d662">00163</a>             std::vector&lt;std::pair&lt;String, String&gt; &gt; customParameters;
<a name="l00164"></a>00164         };
<a name="l00166"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html">00166</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html" title="Struct for holding the script context while parsing.">MaterialScriptContext</a>
<a name="l00167"></a>00167         {
<a name="l00168"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#81f44dba0c5e2328f81d899b525d5aa4">00168</a>             <a class="code" href="classOgre_1_1MaterialScriptCompiler.html#c87b6d292401a48e50ceca7c3bb147dc" title="Enum to identify material sections.">MaterialScriptSection</a> section;
<a name="l00169"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#70eb6b821ab4acb88744c17a6b88c174">00169</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> groupName;
<a name="l00170"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#c4dc01582a182ef1019c9a95249bfee4">00170</a>             <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> material;
<a name="l00171"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#81eea68843db4389bcdbd4120e6ff467">00171</a>             <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* technique;
<a name="l00172"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#3ed3371a080bee51860c639e1161df26">00172</a>             <a class="code" href="classOgre_1_1Pass.html" title="Class defining a single pass of a Technique (of a Material), ie a single rendering...">Pass</a>* pass;
<a name="l00173"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#dcc69913b875d3b947d9c33bea0d8c18">00173</a>             <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique...">TextureUnitState</a>* textureUnit;
<a name="l00174"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#bf614366cdcb8c67eeb030031d311ce7">00174</a>             <a class="code" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a> program; <span class="comment">// used when referencing a program, not when defining it</span>
<a name="l00175"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#f06ebe64719807fcdbf8ab9dae39b363">00175</a>             <span class="keywordtype">bool</span> isProgramShadowCaster; <span class="comment">// when referencing, are we in context of shadow caster</span>
<a name="l00176"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#d1c1b0ccc8c01b6b246e5d8aca06519e">00176</a>             <span class="keywordtype">bool</span> isVertexProgramShadowReceiver; <span class="comment">// when referencing, are we in context of shadow caster</span>
<a name="l00177"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#10b8aaace30f3b479f3c254a09245ea5">00177</a>             <span class="keywordtype">bool</span> isFragmentProgramShadowReceiver; <span class="comment">// when referencing, are we in context of shadow caster</span>
<a name="l00178"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#d3585d8495d69bd3eeae65d6cbfdb664">00178</a>             <span class="keywordtype">bool</span> allowOverride; <span class="comment">// if true then allow existing materials and gpu programs to be overriden</span>
<a name="l00179"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#e76d0ddebf4e237832eb58ff2b7bc09f">00179</a>             <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">GpuProgramParametersSharedPtr</a> programParams;
<a name="l00180"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#fe61f7f3023c2078e9113b131bc3f419">00180</a>             <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> numAnimationParametrics;
<a name="l00181"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#1ab4cdc0414377a836984f34c7e25c60">00181</a>             <a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptProgramDefinition.html" title="Struct for holding a program definition which is in progress.">MaterialScriptProgramDefinition</a>* programDef; <span class="comment">// this is used while defining a program</span>
<a name="l00182"></a>00182 
<a name="l00183"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#12a7840fbbcfe93dd18928220cabf008">00183</a>             <span class="keywordtype">int</span> techLev,    <span class="comment">//Keep track of what tech, pass, and state level we are in</span>
<a name="l00184"></a>00184                 passLev,
<a name="l00185"></a>00185                 stateLev;
<a name="l00186"></a>00186             <span class="comment">// container of token que positions for default params that require pass 2 processing</span>
<a name="l00187"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#cc0f45881db2f330073b5a4dca822427">00187</a>             std::vector&lt;size_t&gt; pendingDefaultParams;
<a name="l00188"></a>00188 
<a name="l00189"></a><a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html#ca41a9f91d85e2c579284179378ec927">00189</a>             <a class="code" href="namespaceOgre.html#5dafc9e68bde8099ec5ad6c94e4cf19b" title="Alias / Texture name pair (first = alias, second = texture name).">AliasTextureNamePairList</a> textureAliases;
<a name="l00190"></a>00190         };
<a name="l00191"></a>00191 
<a name="l00192"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#7d34cc882ee2906f6264399dca9ef698">00192</a>         <a class="code" href="structOgre_1_1MaterialScriptCompiler_1_1MaterialScriptContext.html" title="Struct for holding the script context while parsing.">MaterialScriptContext</a> mScriptContext;
<a name="l00193"></a>00193 
<a name="l00194"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#b6ef995af7f47b44d9e4dd4559565de6">00194</a>         <span class="keyword">typedef</span> void (<a class="code" href="classOgre_1_1MaterialScriptCompiler.html">MaterialScriptCompiler</a>::* MSC_Action)(void);
<a name="l00195"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#3e13b3cb1758f9f4c55096726445d906">00195</a>         <span class="keyword">typedef</span> std::map&lt;size_t, MSC_Action&gt; TokenActionMap;
<a name="l00196"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#dcd98045fcc80392693c6b40eb05d092">00196</a>         <span class="keyword">typedef</span> TokenActionMap::iterator TokenActionIterator;
<a name="l00201"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#b071577835f32857a7ffe33ef66b849b">00201</a>         <span class="keyword">static</span> TokenActionMap mTokenActionMap;
<a name="l00202"></a>00202 
<a name="l00206"></a>00206         <span class="keyword">virtual</span> <span class="keywordtype">void</span> executeTokenAction(<span class="keyword">const</span> <span class="keywordtype">size_t</span> tokenID);
<a name="l00209"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#f161fb7d9447f605c94a03716038e81f">00209</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getAutoTokenIDStart()<span class="keyword"> const </span>{<span class="keywordflow">return</span> ID_AUTOTOKENSTART;}
<a name="l00210"></a>00210 
<a name="l00213"></a>00213         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setupTokenDefinitions(<span class="keywordtype">void</span>);
<a name="l00214"></a>00214         <span class="keywordtype">void</span> addLexemeTokenAction(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; lexeme, <span class="keyword">const</span> <span class="keywordtype">size_t</span> token, <span class="keyword">const</span> MSC_Action action = 0);
<a name="l00218"></a><a class="code" href="classOgre_1_1MaterialScriptCompiler.html#23051390cd87f4fe216525d778f7049e">00218</a>         <span class="keywordtype">void</span> addLexemeAction(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; lexeme, <span class="keyword">const</span> MSC_Action action) {addLexemeTokenAction(lexeme, 0, action);}
<a name="l00219"></a>00219 
<a name="l00220"></a>00220         <span class="keywordtype">void</span> logParseError(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; error);
<a name="l00221"></a>00221 
<a name="l00222"></a>00222         <span class="comment">// support methods that convert tokens</span>
<a name="l00223"></a>00223         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> _parseColourValue(<span class="keywordtype">void</span>);
<a name="l00224"></a>00224         <a class="code" href="namespaceOgre.html#0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> convertCompareFunction(<span class="keywordtype">void</span>);
<a name="l00225"></a>00225 
<a name="l00226"></a>00226         <span class="comment">// Token Actions which get called when tokens are created during parsing.</span>
<a name="l00227"></a>00227         <span class="keywordtype">void</span> parseOpenBrace(<span class="keywordtype">void</span>);
<a name="l00228"></a>00228         <span class="keywordtype">void</span> parseCloseBrace(<span class="keywordtype">void</span>);
<a name="l00229"></a>00229         <span class="comment">// material section Actions</span>
<a name="l00230"></a>00230         <span class="keywordtype">void</span> parseMaterial(<span class="keywordtype">void</span>);
<a name="l00231"></a>00231         <span class="keywordtype">void</span> parseLodDistances(<span class="keywordtype">void</span>);
<a name="l00232"></a>00232         <span class="keywordtype">void</span> parseReceiveShadows(<span class="keywordtype">void</span>);
<a name="l00233"></a>00233         <span class="keywordtype">void</span> parseTransparencyCastsShadows(<span class="keywordtype">void</span>);
<a name="l00234"></a>00234         <span class="keywordtype">void</span> parseSetTextureAlias(<span class="keywordtype">void</span>);
<a name="l00235"></a>00235         <span class="comment">// Technique related actions</span>
<a name="l00236"></a>00236         <span class="keywordtype">void</span> parseTechnique(<span class="keywordtype">void</span>);
<a name="l00237"></a>00237         <span class="keywordtype">void</span> parseScheme(<span class="keywordtype">void</span>);
<a name="l00238"></a>00238         <span class="keywordtype">void</span> parseLodIndex(<span class="keywordtype">void</span>);
<a name="l00239"></a>00239         <span class="comment">// Pass related Actions</span>
<a name="l00240"></a>00240         <span class="keywordtype">void</span> parsePass(<span class="keywordtype">void</span>);
<a name="l00241"></a>00241         <span class="keywordtype">void</span> parseAmbient(<span class="keywordtype">void</span>);
<a name="l00242"></a>00242         <span class="keywordtype">void</span> parseDiffuse(<span class="keywordtype">void</span>);
<a name="l00243"></a>00243         <span class="keywordtype">void</span> parseSpecular(<span class="keywordtype">void</span>);
<a name="l00244"></a>00244         <span class="keywordtype">void</span> parseEmissive(<span class="keywordtype">void</span>);
<a name="l00245"></a>00245         <span class="keywordtype">void</span> parseSceneBlend(<span class="keywordtype">void</span>);
<a name="l00246"></a>00246         <a class="code" href="namespaceOgre.html#41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> convertBlendFactor(<span class="keywordtype">void</span>);
<a name="l00247"></a>00247         <span class="keywordtype">void</span> parseDepthCheck(<span class="keywordtype">void</span>);
<a name="l00248"></a>00248         <span class="keywordtype">void</span> parseDepthWrite(<span class="keywordtype">void</span>);
<a name="l00249"></a>00249         <span class="keywordtype">void</span> parseDepthFunc(<span class="keywordtype">void</span>);
<a name="l00250"></a>00250         <span class="keywordtype">void</span> parseDepthBias(<span class="keywordtype">void</span>);
<a name="l00251"></a>00251         <span class="keywordtype">void</span> parseAlphaRejection(<span class="keywordtype">void</span>);
<a name="l00252"></a>00252         <span class="keywordtype">void</span> parseCullHardware(<span class="keywordtype">void</span>);
<a name="l00253"></a>00253         <span class="keywordtype">void</span> parseCullSoftware(<span class="keywordtype">void</span>);
<a name="l00254"></a>00254         <span class="keywordtype">void</span> parseLighting(<span class="keywordtype">void</span>);
<a name="l00255"></a>00255         <span class="keywordtype">void</span> parseShading(<span class="keywordtype">void</span>);
<a name="l00256"></a>00256         <span class="keywordtype">void</span> parsePolygonMode(<span class="keywordtype">void</span>);
<a name="l00257"></a>00257         <span class="keywordtype">void</span> parseFogOverride(<span class="keywordtype">void</span>);
<a name="l00258"></a>00258         <span class="keywordtype">void</span> parseMaxLights(<span class="keywordtype">void</span>);
<a name="l00259"></a>00259         <span class="keywordtype">void</span> parseStartLight(<span class="keywordtype">void</span>);
<a name="l00260"></a>00260         <span class="keywordtype">void</span> parseIteration(<span class="keywordtype">void</span>);
<a name="l00261"></a>00261         <span class="keywordtype">void</span> parseIterationLightTypes(<span class="keywordtype">void</span>);
<a name="l00262"></a>00262         <span class="keywordtype">void</span> parseColourWrite(<span class="keywordtype">void</span>);
<a name="l00263"></a>00263         <span class="keywordtype">void</span> parsePointSize(<span class="keywordtype">void</span>);
<a name="l00264"></a>00264         <span class="keywordtype">void</span> parsePointSprites(<span class="keywordtype">void</span>);
<a name="l00265"></a>00265         <span class="keywordtype">void</span> parsePointSizeMin(<span class="keywordtype">void</span>);
<a name="l00266"></a>00266         <span class="keywordtype">void</span> parsePointSizeMax(<span class="keywordtype">void</span>);
<a name="l00267"></a>00267         <span class="keywordtype">void</span> parsePointSizeAttenuation(<span class="keywordtype">void</span>);
<a name="l00268"></a>00268         <span class="comment">// Texture Unit related Actions</span>
<a name="l00269"></a>00269         <span class="keywordtype">void</span> parseTextureUnit(<span class="keywordtype">void</span>);
<a name="l00270"></a>00270         <span class="keywordtype">void</span> parseTextureAlias(<span class="keywordtype">void</span>);
<a name="l00271"></a>00271         <span class="keywordtype">void</span> parseTexture(<span class="keywordtype">void</span>);
<a name="l00272"></a>00272         <span class="keywordtype">void</span> parseAnimTexture(<span class="keywordtype">void</span>);
<a name="l00273"></a>00273         <span class="keywordtype">void</span> parseCubicTexture(<span class="keywordtype">void</span>);
<a name="l00274"></a>00274         <span class="keywordtype">void</span> parseTexCoord(<span class="keywordtype">void</span>);
<a name="l00275"></a>00275         <a class="code" href="classOgre_1_1TextureUnitState.html#47c5a9f4fc08159b99bdc51103bcf852" title="Texture addressing modes - default is TAM_WRAP.">TextureUnitState::TextureAddressingMode</a> convTexAddressMode(<span class="keywordtype">void</span>);
<a name="l00276"></a>00276         <span class="keywordtype">void</span> parseTexAddressMode(<span class="keywordtype">void</span>);
<a name="l00277"></a>00277         <span class="keywordtype">void</span> parseTexBorderColour(<span class="keywordtype">void</span>);
<a name="l00278"></a>00278         <span class="keywordtype">void</span> parseFiltering(<span class="keywordtype">void</span>);
<a name="l00279"></a>00279         <a class="code" href="namespaceOgre.html#02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> convertFiltering();
<a name="l00280"></a>00280         <span class="keywordtype">void</span> parseMaxAnisotropy(<span class="keywordtype">void</span>);
<a name="l00281"></a>00281         <span class="keywordtype">void</span> parseMipMapBias(<span class="keywordtype">void</span>);
<a name="l00282"></a>00282         <span class="keywordtype">void</span> parseColourOp(<span class="keywordtype">void</span>);
<a name="l00283"></a>00283         <span class="keywordtype">void</span> parseColourOpEx(<span class="keywordtype">void</span>);
<a name="l00284"></a>00284         <a class="code" href="namespaceOgre.html#264ecab38a04d01e2c3158fa05ec1ee2" title="Expert list of valid texture blending operations, for use with TextureUnitState::setColourOperationE...">LayerBlendOperationEx</a> convertBlendOpEx(<span class="keywordtype">void</span>);
<a name="l00285"></a>00285         <a class="code" href="namespaceOgre.html#e2ad78de344f35307ce35157c175625e" title="List of valid sources of values for blending operations used in TextureUnitState::setColourOperation...">LayerBlendSource</a> convertBlendSource(<span class="keywordtype">void</span>);
<a name="l00286"></a>00286         <span class="keywordtype">void</span> parseColourOpMultipassFallback(<span class="keywordtype">void</span>);
<a name="l00287"></a>00287         <span class="keywordtype">void</span> parseAlphaOpEx(<span class="keywordtype">void</span>);
<a name="l00288"></a>00288         <span class="keywordtype">void</span> parseEnvMap(<span class="keywordtype">void</span>);
<a name="l00289"></a>00289         <span class="keywordtype">void</span> parseScroll(<span class="keywordtype">void</span>);
<a name="l00290"></a>00290         <span class="keywordtype">void</span> parseScrollAnim(<span class="keywordtype">void</span>);
<a name="l00291"></a>00291         <span class="keywordtype">void</span> parseRotate(<span class="keywordtype">void</span>);
<a name="l00292"></a>00292         <span class="keywordtype">void</span> parseRotateAnim(<span class="keywordtype">void</span>);
<a name="l00293"></a>00293         <span class="keywordtype">void</span> parseScale(<span class="keywordtype">void</span>);
<a name="l00294"></a>00294         <span class="keywordtype">void</span> parseWaveXform(<span class="keywordtype">void</span>);
<a name="l00295"></a>00295         <span class="keywordtype">void</span> parseTransform(<span class="keywordtype">void</span>);
<a name="l00296"></a>00296         <span class="keywordtype">void</span> parseTextureCustomParameter(<span class="keywordtype">void</span>);
<a name="l00297"></a>00297         <span class="keywordtype">void</span> parseBindingType(<span class="keywordtype">void</span>);
<a name="l00298"></a>00298         <span class="keywordtype">void</span> parseContentType(<span class="keywordtype">void</span>);
<a name="l00299"></a>00299 
<a name="l00300"></a>00300         <span class="comment">// GPU Program</span>
<a name="l00301"></a>00301         <span class="keywordtype">void</span> parseGPUProgram(<span class="keywordtype">void</span>);
<a name="l00302"></a>00302         <span class="keywordtype">void</span> parseProgramSource(<span class="keywordtype">void</span>);
<a name="l00303"></a>00303         <span class="keywordtype">void</span> parseProgramSyntax(<span class="keywordtype">void</span>);
<a name="l00304"></a>00304         <span class="keywordtype">void</span> parseProgramCustomParameter(<span class="keywordtype">void</span>);
<a name="l00305"></a>00305         <span class="keywordtype">void</span> parseDefaultParams(<span class="keywordtype">void</span>);
<a name="l00306"></a>00306         <span class="keywordtype">void</span> parseProgramSkeletalAnimation(<span class="keywordtype">void</span>);
<a name="l00307"></a>00307         <span class="keywordtype">void</span> parseProgramMorphAnimation(<span class="keywordtype">void</span>);
<a name="l00308"></a>00308         <span class="keywordtype">void</span> parseProgramPoseAnimation(<span class="keywordtype">void</span>);
<a name="l00309"></a>00309         <span class="keywordtype">void</span> parseProgramVertexTextureFetch(<span class="keywordtype">void</span>);
<a name="l00310"></a>00310         <span class="keywordtype">void</span> parseVertexProgramRef(<span class="keywordtype">void</span>);
<a name="l00311"></a>00311         <span class="keywordtype">void</span> parseFragmentProgramRef(<span class="keywordtype">void</span>);
<a name="l00312"></a>00312         <span class="keywordtype">void</span> parseShadowCasterVertexProgramRef(<span class="keywordtype">void</span>);
<a name="l00313"></a>00313         <span class="keywordtype">void</span> parseShadowReceiverVertexProgramRef(<span class="keywordtype">void</span>);
<a name="l00314"></a>00314         <span class="keywordtype">void</span> parseShadowReceiverFragmentProgramRef(<span class="keywordtype">void</span>);
<a name="l00315"></a>00315         <span class="keywordtype">void</span> parseParamIndexed(<span class="keywordtype">void</span>);
<a name="l00316"></a>00316         <span class="keywordtype">void</span> parseParamIndexedAuto(<span class="keywordtype">void</span>);
<a name="l00317"></a>00317         <span class="keywordtype">void</span> parseParamNamed(<span class="keywordtype">void</span>);
<a name="l00318"></a>00318         <span class="keywordtype">void</span> parseParamNamedAuto(<span class="keywordtype">void</span>);
<a name="l00319"></a>00319         <span class="keywordtype">void</span> processManualProgramParam(<span class="keywordtype">bool</span> isNamed, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> commandName, 
<a name="l00320"></a>00320             <span class="keywordtype">size_t</span> index = 0, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; paramName = <a class="code" href="classOgre_1_1StringUtil.html#d2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00321"></a>00321         <span class="keywordtype">void</span> processAutoProgramParam(<span class="keywordtype">bool</span> isNamed, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> commandName, 
<a name="l00322"></a>00322             <span class="keywordtype">size_t</span> index, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; paramName = <a class="code" href="classOgre_1_1StringUtil.html#d2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 
<a name="l00325"></a>00325         <span class="keywordtype">void</span> finishProgramDefinition(<span class="keywordtype">void</span>);
<a name="l00326"></a>00326 
<a name="l00327"></a>00327     };
<a name="l00328"></a>00328 }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:52 2008
</p>
</body>
</html>
